<?php
require_once("../../config/config_dir_raiz.php");
$config = new Config();
require_once($config->diretorio_raiz()."/src/controller/Funcoes_bd.php");
require_once($config->diretorio_raiz()."/src/model/Bi_operador.php");
class Bi_operadorDAO
{
	private $_funcoes_bd;
	private $_banco_atual;
	private $conexao;
	function __construct()
	{
		$this->conexao = Conexao::obterConexao();
		$this->_banco_atual = Conexao::getUtilizarBanco();
		$this->_funcoes_bd = new Funcoes_bd();
	}
	public function salvar($bi_operador)
	{
		$inputs = array();
		if($bi_operador->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_operador->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_operador->getDescricao() != "")
		{
			array_push($inputs, array('campo'=>':descricao', 'valor'=>$bi_operador->getDescricao()));
		}
		else
		{
			array_push($inputs, array('campo'=>':descricao', 'valor'=>null));
		}
		if($bi_operador->getOperador() != "")
		{
			array_push($inputs, array('campo'=>':operador', 'valor'=>$bi_operador->getOperador()));
		}
		else
		{
			array_push($inputs, array('campo'=>':operador', 'valor'=>null));
		}
		try
		{
			$sql = "INSERT INTO bi_operador (codigo, descricao, operador) VALUES (:codigo, :descricao, :operador)  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function buscarBi_operador($codigo)
	{
		$inputs = array();
		array_push($inputs, array('campo'=>':codigo', 'valor'=>$codigo));
		$sql = "SELECT * FROM bi_operador where codigo = :codigo "; 
		$bi_operador = new Bi_operador();
		$rows_bi_operador = $this->_funcoes_bd->sqlArrayInputs($sql, $inputs);
		foreach ($rows_bi_operador as $row)
		{
			$bi_operador->setCodigo($row['codigo']);
			$bi_operador->setDescricao($row['descricao']);
			$bi_operador->setOperador($row['operador']);
		}
		return $bi_operador;
	}
	public function buscarFiltro($where)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_operador  ".$where;
		$lista_bi_operador = array();
		$rows_bi_operador = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_operador as $row)
		{
			$bi_operador = new Bi_operador();
			$bi_operador->setCodigo($row['codigo']);
			$bi_operador->setDescricao($row['descricao']);
			$bi_operador->setOperador($row['operador']);
			array_push($lista_bi_operador, $bi_operador);
		}
		return $lista_bi_operador;
	}
	public function atualizar($bi_operador)
	{
		$inputs = array();
		if($bi_operador->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_operador->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_operador->getDescricao() != "")
		{
			array_push($inputs, array('campo'=>':descricao', 'valor'=>$bi_operador->getDescricao()));
		}
		else
		{
			array_push($inputs, array('campo'=>':descricao', 'valor'=>null));
		}
		if($bi_operador->getOperador() != "")
		{
			array_push($inputs, array('campo'=>':operador', 'valor'=>$bi_operador->getOperador()));
		}
		else
		{
			array_push($inputs, array('campo'=>':operador', 'valor'=>null));
		}
		try
		{
			$sql = "UPDATE  bi_operador  SET codigo = :codigo, descricao = :descricao, operador = :operador WHERE codigo = :codigo  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function excluir($bi_operador)
	{
		try
		{
			$sql = "DELETE FROM bi_operador  WHERE codigo =  :codigo ";
			$inputs = array();
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_operador->getCodigo()));
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function listarTodosRegistros()
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_operador";
		$listaBi_operador = array();
		$rows_bi_operador = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_operador as $row)
		{
			$bi_operador = new Bi_operador();
			$bi_operador->setCodigo($row['codigo']);
			$bi_operador->setDescricao($row['descricao']);
			$bi_operador->setOperador($row['operador']);
			array_push($listaBi_operador,$bi_operador );
		}
		return $listaBi_operador;
	}
	public function buscarBi_operadorPorDescricao($descricao)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_operador where descricao like '%".$descricao."%'";
		$lista_bi_operador = array();
		$rows_bi_operador = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_operador as $row)
		{
			$bi_operador = new Bi_operador();
			$bi_operador->setCodigo($row['codigo']);
			$bi_operador->setDescricao($row['descricao']);
			$bi_operador->setOperador($row['operador']);
			array_push($lista_bi_operador, $bi_operador);
		}
		return $lista_bi_operador;
	}
	public function buscarBi_operadorPorOperador($operador)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_operador where operador like '%".$operador."%'";
		$lista_bi_operador = array();
		$rows_bi_operador = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_operador as $row)
		{
			$bi_operador = new Bi_operador();
			$bi_operador->setCodigo($row['codigo']);
			$bi_operador->setDescricao($row['descricao']);
			$bi_operador->setOperador($row['operador']);
			array_push($lista_bi_operador, $bi_operador);
		}
		return $lista_bi_operador;
	}
}